//rob@m0dts.co.uk 2015
//www.m0dts.co.uk

module ssbdemod (
		input clockin,
		input signed [7:0] VFOI,
		input signed [7:0] VFOQ,
		input signed [7:0] I,
		input signed [7:0] Q,
		output signed [7:0] ssb
);





parameter taps=101;
reg signed [31:0] fil_sumI,fil_sumQ,ssbsum,tempssb;
reg signed [7:0] coeff [taps-1:0];
reg signed [7:0] fil_bufI [taps-1:0];
reg signed [7:0] fil_bufQ [taps-1:0];
reg signed [7:0] sumtmpI,sumtmpQ;
reg signed [15:0] tempI,tempQ;
reg [32:0] dec=1;
integer i;	
reg [16:0] pos=0;
	 
initial
begin
	$readmemh ("fir2.hex", coeff);
end


assign ssb = tempssb;//fil_sumI[7:0];




always @ (posedge clockin)
begin




		
		for(i=taps-1; i>0; i=i-1) 
		begin
			fil_bufI[i] = fil_bufI[i-1];
			fil_bufQ[i] = fil_bufQ[i-1];
		end
		
		
		//load new IQ into bufs
		fil_bufI[0] = I;
		fil_bufQ[0] = Q;
		
		fil_sumI = 0;
		fil_sumQ = 0;
		//apply coeff
		for(i=0; i<taps; i=i+1) 
		begin	
			fil_sumI = fil_sumI + (fil_bufI[i] * coeff[i]);
			fil_sumQ = fil_sumQ + (fil_bufQ[i] * coeff[i]);
		end
		
		sumtmpI = fil_sumI>>>8;
		sumtmpQ = fil_sumQ>>>8;
		
		tempI = sumtmpI*VFOI;
		tempQ = sumtmpQ*VFOQ;

		tempI = tempI>>>7;
		tempQ = tempQ>>>7;
		
		tempssb <= (tempI+tempQ);//fil_sumI[7:0];//+tempQ[7:0];

		

end


endmodule
